Attribute VB_Name = "PKCS11Defs"
'''''''''''''''''''''''''''''''''''''
' PKCS#11 definitions
' Data: 27/10/2008
' Author: Ugo Chirico
' http://www.ugosweb.com
' Copyrigth (c) 2008 by Ugo Chirico All rigths reserved
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Const CKR_OK = &H0
Public Const CKR_CANCEL = &H1
Public Const CKR_HOST_MEMORY = &H2
Public Const CKR_SLOT_ID_INVALID = &H3

' CKR_FLAGS_INVALID was removed for v2.0 '/

' CKR_GENERAL_ERROR and CKR_FUNCTION_FAILED are new for v2.0 '/
Public Const CKR_GENERAL_ERROR = &H5
Public Const CKR_FUNCTION_FAILED = &H6

' CKR_ARGUMENTS_BAD, CKR_NO_EVENT, CKR_NEED_TO_CREATE_THREADS,
 ' and CKR_CANT_LOCK are new for v2.01 '/
Public Const CKR_ARGUMENTS_BAD = &H7
Public Const CKR_NO_EVENT = &H8
Public Const CKR_NEED_TO_CREATE_THREADS = &H9
Public Const CKR_CANT_LOCK = &HA

Public Const CKR_ATTRIBUTE_READ_ONLY = &H10
Public Const CKR_ATTRIBUTE_SENSITIVE = &H11
Public Const CKR_ATTRIBUTE_TYPE_INVALID = &H12
Public Const CKR_ATTRIBUTE_VALUE_INVALID = &H13
Public Const CKR_DATA_INVALID = &H20
Public Const CKR_DATA_LEN_RANGE = &H21
Public Const CKR_DEVICE_ERROR = &H30
Public Const CKR_DEVICE_MEMORY = &H31
Public Const CKR_DEVICE_REMOVED = &H32
Public Const CKR_ENCRYPTED_DATA_INVALID = &H40
Public Const CKR_ENCRYPTED_DATA_LEN_RANGE = &H41
Public Const CKR_FUNCTION_CANCELED = &H50
Public Const CKR_FUNCTION_NOT_PARALLEL = &H51

' CKR_FUNCTION_NOT_SUPPORTED is new for v2.0 '/
Public Const CKR_FUNCTION_NOT_SUPPORTED = &H54

Public Const CKR_KEY_HANDLE_INVALID = &H60

' CKR_KEY_SENSITIVE was removed for v2.0 '/

Public Const CKR_KEY_SIZE_RANGE = &H62
Public Const CKR_KEY_TYPE_INCONSISTENT = &H63

' CKR_KEY_NOT_NEEDED, CKR_KEY_CHANGED, CKR_KEY_NEEDED,
 ' CKR_KEY_INDIGESTIBLE, CKR_KEY_FUNCTION_NOT_PERMITTED,
 ' CKR_KEY_NOT_WRAPPABLE, and CKR_KEY_UNEXTRACTABLE are new for
 ' v2.0 '/
Public Const CKR_KEY_NOT_NEEDED = &H64
Public Const CKR_KEY_CHANGED = &H65
Public Const CKR_KEY_NEEDED = &H66
Public Const CKR_KEY_INDIGESTIBLE = &H67
Public Const CKR_KEY_FUNCTION_NOT_PERMITTED = &H68
Public Const CKR_KEY_NOT_WRAPPABLE = &H69
Public Const CKR_KEY_UNEXTRACTABLE = &H6A

Public Const CKR_MECHANISM_INVALID = &H70
Public Const CKR_MECHANISM_PARAM_INVALID = &H71

' CKR_OBJECT_CLASS_INCONSISTENT and CKR_OBJECT_CLASS_INVALID
 ' were removed for v2.0 '/
Public Const CKR_OBJECT_HANDLE_INVALID = &H82
Public Const CKR_OPERATION_ACTIVE = &H90
Public Const CKR_OPERATION_NOT_INITIALIZED = &H91
Public Const CKR_PIN_INCORRECT = &HA0
Public Const CKR_PIN_INVALID = &HA1
Public Const CKR_PIN_LEN_RANGE = &HA2

' CKR_PIN_EXPIRED and CKR_PIN_LOCKED are new for v2.0 '/
Public Const CKR_PIN_EXPIRED = &HA3
Public Const CKR_PIN_LOCKED = &HA4

Public Const CKR_SESSION_CLOSED = &HB0
Public Const CKR_SESSION_COUNT = &HB1
Public Const CKR_SESSION_HANDLE_INVALID = &HB3
Public Const CKR_SESSION_PARALLEL_NOT_SUPPORTED = &HB4
Public Const CKR_SESSION_READ_ONLY = &HB5
Public Const CKR_SESSION_EXISTS = &HB6

' CKR_SESSION_READ_ONLY_EXISTS and
 ' CKR_SESSION_READ_WRITE_SO_EXISTS are new for v2.0 '/
Public Const CKR_SESSION_READ_ONLY_EXISTS = &HB7
Public Const CKR_SESSION_READ_WRITE_SO_EXISTS = &HB8

Public Const CKR_SIGNATURE_INVALID = &HC0
Public Const CKR_SIGNATURE_LEN_RANGE = &HC1
Public Const CKR_TEMPLATE_INCOMPLETE = &HD0
Public Const CKR_TEMPLATE_INCONSISTENT = &HD1
Public Const CKR_TOKEN_NOT_PRESENT = &HE0
Public Const CKR_TOKEN_NOT_RECOGNIZED = &HE1
Public Const CKR_TOKEN_WRITE_PROTECTED = &HE2
Public Const CKR_UNWRAPPING_KEY_HANDLE_INVALID = &HF0
Public Const CKR_UNWRAPPING_KEY_SIZE_RANGE = &HF1
Public Const CKR_UNWRAPPING_KEY_TYPE_INCONSISTENT = &HF2
Public Const CKR_USER_ALREADY_LOGGED_IN = &H100
Public Const CKR_USER_NOT_LOGGED_IN = &H101
Public Const CKR_USER_PIN_NOT_INITIALIZED = &H102
Public Const CKR_USER_TYPE_INVALID = &H103

' CKR_USER_ANOTHER_ALREADY_LOGGED_IN and CKR_USER_TOO_MANY_TYPES
 ' are new to v2.01 '/
Public Const CKR_USER_ANOTHER_ALREADY_LOGGED_IN = &H104
Public Const CKR_USER_TOO_MANY_TYPES = &H105

Public Const CKR_WRAPPED_KEY_INVALID = &H110
Public Const CKR_WRAPPED_KEY_LEN_RANGE = &H112
Public Const CKR_WRAPPING_KEY_HANDLE_INVALID = &H113
Public Const CKR_WRAPPING_KEY_SIZE_RANGE = &H114
Public Const CKR_WRAPPING_KEY_TYPE_INCONSISTENT = &H115
Public Const CKR_RANDOM_SEED_NOT_SUPPORTED = &H120

' These are new to v2.0 '/
Public Const CKR_RANDOM_NO_RNG = &H121

' These are new to v2.11 '/
Public Const CKR_DOMAIN_PARAMS_INVALID = &H130

' These are new to v2.0 '/
Public Const CKR_BUFFER_TOO_SMALL = &H150
Public Const CKR_SAVED_STATE_INVALID = &H160
Public Const CKR_INFORMATION_SENSITIVE = &H170
Public Const CKR_STATE_UNSAVEABLE = &H180

' These are new to v2.01 '/
Public Const CKR_CRYPTOKI_NOT_INITIALIZED = &H190
Public Const CKR_CRYPTOKI_ALREADY_INITIALIZED = &H191
Public Const CKR_MUTEX_BAD = &H1A0
Public Const CKR_MUTEX_NOT_LOCKED = &H1A1

Public Const CKR_VENDOR_DEFINED = &H80000000
'''''''''''''''''''''''''''''''''''''''
Public Const CKF_DONT_BLOCK = 1

'''''''''''''''''''''''''''''
Public Const CKU_USER = &H1
Public Const CKU_SO = &H2

'''''''''''''''''''''''''
' ATTRIBUTES
'
Public Const CKH_MONOTONIC_COUNTER = &H1
Public Const CKH_CLOCK = &H2
Public Const CKH_VENDOR_DEFINED = &H80000000

' The following attribute types are defined: '/
Public Const CKA_CLASS = &H0
Public Const CKA_TOKEN = &H1
Public Const CKA_PRIVATE = &H2
Public Const CKA_LABEL = &H3
Public Const CKA_APPLICATION = &H10
Public Const CKA_VALUE = &H11

' CKA_OBJECT_ID is new for v2.10 '/
Public Const CKA_OBJECT_ID = &H12

Public Const CKA_CERTIFICATE_TYPE = &H80
Public Const CKA_ISSUER = &H81
Public Const CKA_SERIAL_NUMBER = &H82

' CKA_AC_ISSUER, CKA_OWNER, and CKA_ATTR_TYPES are new
 ' for v2.10 '/
Public Const CKA_AC_ISSUER = &H83
Public Const CKA_OWNER = &H84
Public Const CKA_ATTR_TYPES = &H85
' CKA_TRUSTED is new for v2.11 '/
Public Const CKA_TRUSTED = &H86
Public Const CKA_KEY_TYPE = &H100
Public Const CKA_SUBJECT = &H101
Public Const CKA_ID = &H102
Public Const CKA_SENSITIVE = &H103
Public Const CKA_ENCRYPT = &H104
Public Const CKA_DECRYPT = &H105
Public Const CKA_WRAP = &H106
Public Const CKA_UNWRAP = &H107
Public Const CKA_SIGN = &H108
Public Const CKA_SIGN_RECOVER = &H109
Public Const CKA_VERIFY = &H10A
Public Const CKA_VERIFY_RECOVER = &H10B
Public Const CKA_DERIVE = &H10C
Public Const CKA_START_DATE = &H110
Public Const CKA_END_DATE = &H111
Public Const CKA_MODULUS = &H120
Public Const CKA_MODULUS_BITS = &H121
Public Const CKA_PUBLIC_EXPONENT = &H122
Public Const CKA_PRIVATE_EXPONENT = &H123
Public Const CKA_PRIME_1 = &H124
Public Const CKA_PRIME_2 = &H125
Public Const CKA_EXPONENT_1 = &H126
Public Const CKA_EXPONENT_2 = &H127
Public Const CKA_COEFFICIENT = &H128
Public Const CKA_PRIME = &H130
Public Const CKA_SUBPRIME = &H131
Public Const CKA_BASE = &H132

Public Const CKA_PRIME_BITS = &H133
Public Const CKA_SUBPRIME_BITS = &H134
Public Const CKA_SUB_PRIME_BITS = CKA_SUBPRIME_BITS

Public Const CKA_VALUE_BITS = &H160
Public Const CKA_VALUE_LEN = &H161



' CKA_EXTRACTABLE, CKA_LOCAL, CKA_NEVER_EXTRACTABLE,
 ' CKA_ALWAYS_SENSITIVE, CKA_MODIFIABLE, CKA_ECDSA_PARAMS,
 ' and CKA_EC_POuint are new for v2.0 '/
Public Const CKA_EXTRACTABLE = &H162
Public Const CKA_LOCAL = &H163
Public Const CKA_NEVER_EXTRACTABLE = &H164
Public Const CKA_ALWAYS_SENSITIVE = &H165
' CKA_KEY_GEN_MECHANISM is new for v2.11 '/
Public Const CKA_KEY_GEN_MECHANISM = &H166
Public Const CKA_MODIFIABLE = &H170
Public Const CKA_ECDSA_PARAMS = &H180
Public Const CKA_EC_POINT = &H181

' CKA_SECONDARY_AUTH, CKA_AUTH_PIN_FLAGS,
 ' CKA_HW_FEATURE_TYPE, CKA_RESET_ON_INIT, and CKA_HAS_RESET
 ' are new for v2.10 '/
Public Const CKA_SECONDARY_AUTH = &H200
Public Const CKA_AUTH_PIN_FLAGS = &H201
Public Const CKA_HW_FEATURE_TYPE = &H300
Public Const CKA_RESET_ON_INIT = &H301
Public Const CKA_HAS_RESET = &H302

Public Const CKA_PIXEL_X = &H400
Public Const CKA_PIXEL_Y = &H401
Public Const CKA_RESOLUTION = &H402
Public Const CKA_CHAR_ROWS = &H403
Public Const CKA_CHAR_COLUMNS = &H404
Public Const CKA_COLOR = &H405
Public Const CKA_BITS_PER_PIXEL = &H406
Public Const CKA_CHAR_SETS = &H480
Public Const CKA_ENCODING_METHODS = &H481
Public Const CKA_MIME_TYPES = &H482
Public Const CKA_MECHANISM_TYPE = &H500
Public Const CKA_REQUIRED_CMS_ATTRIBUTES = &H501
Public Const CKA_DEFAULT_CMS_ATTRIBUTES = &H502
Public Const CKA_SUPPORTED_CMS_ATTRIBUTES = &H503

Public Const CKA_VENDOR_DEFINED = &H80000000


'''''''''''''''''''''''''
' OBJECTS
Public Const CKO_DATA = &H0
Public Const CKO_CERTIFICATE = &H1
Public Const CKO_PUBLIC_KEY = &H2
Public Const CKO_PRIVATE_KEY = &H3
Public Const CKO_SECRET_KEY = &H4
Public Const CKO_HW_FEATURE = &H5
Public Const CKO_DOMAIN_PARAMETERS = &H6
Public Const CKO_MECHANISM = &H7
Public Const CKO_VENDOR_DEFINED = &H80000000

' The flags are defined as follows:
'      Bit Flag               Mask        Meaning '/
Public Const CKF_HW = &H1                          ' performed by HW '/

' The flags CKF_ENCRYPT, CKF_DECRYPT, CKF_DIGEST, CKF_SIGN,
 ' CKG_SIGN_RECOVER, CKF_VERIFY, CKF_VERIFY_RECOVER,
 ' CKF_GENERATE, CKF_GENERATE_KEY_PAIR, CKF_WRAP, CKF_UNWRAP,
 ' and CKF_DERIVE are new for v2.0.  They specify whether or not
 ' a mechanism can be used for a particular task '/
Public Const CKF_ENCRYPT = &H100
Public Const CKF_DECRYPT = &H200
Public Const CKF_DIGEST = &H400
Public Const CKF_SIGN = &H800
Public Const CKF_SIGN_RECOVER = &H1000
Public Const CKF_VERIFY = &H2000
Public Const CKF_VERIFY_RECOVER = &H4000
Public Const CKF_GENERATE = &H8000
Public Const CKF_GENERATE_KEY_PAIR = &H10000
Public Const CKF_WRAP = &H20000
Public Const CKF_UNWRAP = &H40000
Public Const CKF_DERIVE = &H80000

Public Const CKF_EXTENSION = &H80000000            ' FALSE for 2.01 '/

Public Const CKS_RO_PUBLIC_SESSION = 0
Public Const CKS_RO_USER_FUNCTIONS = 1
Public Const CKS_RW_PUBLIC_SESSION = 2
Public Const CKS_RW_USER_FUNCTIONS = 3
Public Const CKS_RW_SO_FUNCTIONS = 4

Public Const CKF_RW_SESSION = &H2              ' session is r/w '/
Public Const CKF_SERIAL_SESSION = &H4          ' no parallel '/

Public Const CKF_RNG = &H1                               ' has random # generator '/
Public Const CKF_WRITE_PROTECTED = &H2                   ' token is  write- protected '/
Public Const CKF_LOGIN_REQUIRED = &H4                    ' user must login '/
Public Const CKF_USER_PIN_INITIALIZED = &H8              ' normal user's PIN is set '/

' CKF_RESTORE_KEY_NOT_NEEDED is new for v2.0.  If it is set,
 ' that means that 'every' time the state of cryptographic
 ' operations of a session is successfully saved, all keys
 ' needed to continue those operations are stored in the state '/
Public Const CKF_RESTORE_KEY_NOT_NEEDED = &H20

' CKF_CLOCK_ON_TOKEN is new for v2.0.  If it is set, that means
 ' that the token has some sort of clock.  The time on that
 ' clock is returned in the token info structure '/
Public Const CKF_CLOCK_ON_TOKEN = &H40

' CKF_PROTECTED_AUTHENTICATION_PATH is new for v2.0.  If it is
 ' set, that means that there is some way for the user to login
 ' without sending a PIN through the Cryptoki library itself '/
Public Const CKF_PROTECTED_AUTHENTICATION_PATH = &H100

' CKF_DUAL_CRYPTO_OPERATIONS is new for v2.0.  If it is true,
 ' that means that a single session with the token can perform
 ' dual simultaneous cryptographic operations (digest and
 ' encrypt  decrypt and digest  sign and encrypt  and decrypt
 ' and sign) '/
Public Const CKF_DUAL_CRYPTO_OPERATIONS = &H200

' CKF_TOKEN_INITIALIZED if new for v2.10. If it is true, the
 ' token has been initialized using C_InitializeToken or an
 ' equivalent mechanism outside the scope of PKCS #11.
 ' Calling C_InitializeToken when this flag is set will cause
 ' the token to be reinitialized. '/
Public Const CKF_TOKEN_INITIALIZED = &H400

' CKF_SECONDARY_AUTHENTICATION if new for v2.10. If it is
 ' true, the token supports secondary authentication for
 ' private key objects. '/
Public Const CKF_SECONDARY_AUTHENTICATION = &H800

' CKF_USER_PIN_COUNT_LOW if new for v2.10. If it is true, an
 ' incorrect user login PIN has been entered at least once
 ' since the last successful authentication. '/
Public Const CKF_USER_PIN_COUNT_LOW = &H10000

' CKF_USER_PIN_FINAL_TRY if new for v2.10. If it is true,
 ' supplying an incorrect user PIN will it to become locked. '/
Public Const CKF_USER_PIN_FINAL_TRY = &H20000

' CKF_USER_PIN_LOCKED if new for v2.10. If it is true, the
 ' user PIN has been locked. User login to the token is not
 ' possible. '/
Public Const CKF_USER_PIN_LOCKED = &H40000

' CKF_USER_PIN_TO_BE_CHANGED if new for v2.10. If it is true,
 ' the user PIN value is the default value set by token
 ' initialization or manufacturing. '/
Public Const CKF_USER_PIN_TO_BE_CHANGED = &H80000

' CKF_SO_PIN_COUNT_LOW if new for v2.10. If it is true, an
 ' incorrect SO login PIN has been entered at least once since
 ' the last successful authentication. '/
Public Const CKF_SO_PIN_COUNT_LOW = &H100000

' CKF_SO_PIN_FINAL_TRY if new for v2.10. If it is true,
 ' supplying an incorrect SO PIN will it to become locked. '/
Public Const CKF_SO_PIN_FINAL_TRY = &H200000

' CKF_SO_PIN_LOCKED if new for v2.10. If it is true, the SO
 ' PIN has been locked. SO login to the token is not possible.
 '/
Public Const CKF_SO_PIN_LOCKED = &H400000

' CKF_SO_PIN_TO_BE_CHANGED if new for v2.10. If it is true,
 ' the SO PIN value is the default value set by token
 ' initialization or manufacturing. '/
Public Const CKF_SO_PIN_TO_BE_CHANGED = &H800000

' the following mechanism types are defined: '/
Public Const CKM_RSA_PKCS_KEY_PAIR_GEN = &H0
Public Const CKM_RSA_PKCS = &H1
Public Const CKM_RSA_9796 = &H2
Public Const CKM_RSA_X_509 = &H3

' CKM_MD2_RSA_PKCS, CKM_MD5_RSA_PKCS, and CKM_SHA1_RSA_PKCS
 ' are new for v2.0.  They are mechanisms which hash and sign '/
Public Const CKM_MD2_RSA_PKCS = &H4
Public Const CKM_MD5_RSA_PKCS = &H5
Public Const CKM_SHA1_RSA_PKCS = &H6

' CKM_RIPEMD128_RSA_PKCS, CKM_RIPEMD160_RSA_PKCS, and
 ' CKM_RSA_PKCS_OAEP are new for v2.10 '/
Public Const CKM_RIPEMD128_RSA_PKCS = &H7
Public Const CKM_RIPEMD160_RSA_PKCS = &H8
Public Const CKM_RSA_PKCS_OAEP = &H9

Public Const CKM_DSA_KEY_PAIR_GEN = &H10
Public Const CKM_DSA = &H11
Public Const CKM_DSA_SHA1 = &H12
Public Const CKM_DH_PKCS_KEY_PAIR_GEN = &H20
Public Const CKM_DH_PKCS_DERIVE = &H21
Public Const CKM_RC2_KEY_GEN = &H100
Public Const CKM_RC2_ECB = &H101
Public Const CKM_RC2_CBC = &H102
Public Const CKM_RC2_MAC = &H103

' CKM_RC2_MAC_GENERAL and CKM_RC2_CBC_PAD are new for v2.0 '/
Public Const CKM_RC2_MAC_GENERAL = &H104
Public Const CKM_RC2_CBC_PAD = &H105

Public Const CKM_RC4_KEY_GEN = &H110
Public Const CKM_RC4 = &H111
Public Const CKM_DES_KEY_GEN = &H120
Public Const CKM_DES_ECB = &H121
Public Const CKM_DES_CBC = &H122
Public Const CKM_DES_MAC = &H123

' CKM_DES_MAC_GENERAL and CKM_DES_CBC_PAD are new for v2.0 '/
Public Const CKM_DES_MAC_GENERAL = &H124
Public Const CKM_DES_CBC_PAD = &H125

Public Const CKM_DES2_KEY_GEN = &H130
Public Const CKM_DES3_KEY_GEN = &H131
Public Const CKM_DES3_ECB = &H132
Public Const CKM_DES3_CBC = &H133
Public Const CKM_DES3_MAC = &H134

' CKM_DES3_MAC_GENERAL, CKM_DES3_CBC_PAD, CKM_CDMF_KEY_GEN,
 ' CKM_CDMF_ECB, CKM_CDMF_CBC, CKM_CDMF_MAC,
 ' CKM_CDMF_MAC_GENERAL, and CKM_CDMF_CBC_PAD are new for v2.0 '/
Public Const CKM_DES3_MAC_GENERAL = &H135
Public Const CKM_DES3_CBC_PAD = &H136
Public Const CKM_CDMF_KEY_GEN = &H140
Public Const CKM_CDMF_ECB = &H141
Public Const CKM_CDMF_CBC = &H142
Public Const CKM_CDMF_MAC = &H143
Public Const CKM_CDMF_MAC_GENERAL = &H144
Public Const CKM_CDMF_CBC_PAD = &H145

Public Const CKM_MD2 = &H200

' CKM_MD2_HMAC and CKM_MD2_HMAC_GENERAL are new for v2.0 '/
Public Const CKM_MD2_HMAC = &H201
Public Const CKM_MD2_HMAC_GENERAL = &H202

Public Const CKM_MD5 = &H210

' CKM_MD5_HMAC and CKM_MD5_HMAC_GENERAL are new for v2.0 '/
Public Const CKM_MD5_HMAC = &H211
Public Const CKM_MD5_HMAC_GENERAL = &H212

Public Const CKM_SHA_1 = &H220

' CKM_SHA_1_HMAC and CKM_SHA_1_HMAC_GENERAL are new for v2.0 '/
Public Const CKM_SHA_1_HMAC = &H221
Public Const CKM_SHA_1_HMAC_GENERAL = &H222

' CKM_RIPEMD128, CKM_RIPEMD128_HMAC,
 ' CKM_RIPEMD128_HMAC_GENERAL, CKM_RIPEMD160, CKM_RIPEMD160_HMAC,
 ' and CKM_RIPEMD160_HMAC_GENERAL are new for v2.10 '/
Public Const CKM_RIPEMD128 = &H230
Public Const CKM_RIPEMD128_HMAC = &H231
Public Const CKM_RIPEMD128_HMAC_GENERAL = &H232
Public Const CKM_RIPEMD160 = &H240
Public Const CKM_RIPEMD160_HMAC = &H241
Public Const CKM_RIPEMD160_HMAC_GENERAL = &H242

' All of the following mechanisms are new for v2.0 '/
' Note that CAST128 and CAST5 are the same algorithm '/
Public Const CKM_CAST_KEY_GEN = &H300
Public Const CKM_CAST_ECB = &H301
Public Const CKM_CAST_CBC = &H302
Public Const CKM_CAST_MAC = &H303
Public Const CKM_CAST_MAC_GENERAL = &H304
Public Const CKM_CAST_CBC_PAD = &H305
Public Const CKM_CAST3_KEY_GEN = &H310
Public Const CKM_CAST3_ECB = &H311
Public Const CKM_CAST3_CBC = &H312
Public Const CKM_CAST3_MAC = &H313
Public Const CKM_CAST3_MAC_GENERAL = &H314
Public Const CKM_CAST3_CBC_PAD = &H315
Public Const CKM_CAST5_KEY_GEN = &H320
Public Const CKM_CAST128_KEY_GEN = &H320
Public Const CKM_CAST5_ECB = &H321
Public Const CKM_CAST128_ECB = &H321
Public Const CKM_CAST5_CBC = &H322
Public Const CKM_CAST128_CBC = &H322
Public Const CKM_CAST5_MAC = &H323
Public Const CKM_CAST128_MAC = &H323
Public Const CKM_CAST5_MAC_GENERAL = &H324
Public Const CKM_CAST128_MAC_GENERAL = &H324
Public Const CKM_CAST5_CBC_PAD = &H325
Public Const CKM_CAST128_CBC_PAD = &H325
Public Const CKM_RC5_KEY_GEN = &H330
Public Const CKM_RC5_ECB = &H331
Public Const CKM_RC5_CBC = &H332
Public Const CKM_RC5_MAC = &H333
Public Const CKM_RC5_MAC_GENERAL = &H334
Public Const CKM_RC5_CBC_PAD = &H335
Public Const CKM_IDEA_KEY_GEN = &H340
Public Const CKM_IDEA_ECB = &H341
Public Const CKM_IDEA_CBC = &H342
Public Const CKM_IDEA_MAC = &H343
Public Const CKM_IDEA_MAC_GENERAL = &H344
Public Const CKM_IDEA_CBC_PAD = &H345
Public Const CKM_GENERIC_SECRET_KEY_GEN = &H350
Public Const CKM_CONCATENATE_BASE_AND_KEY = &H360
Public Const CKM_CONCATENATE_BASE_AND_DATA = &H362
Public Const CKM_CONCATENATE_DATA_AND_BASE = &H363
Public Const CKM_XOR_BASE_AND_DATA = &H364
Public Const CKM_EXTRACT_KEY_FROM_KEY = &H365
Public Const CKM_SSL3_PRE_MASTER_KEY_GEN = &H370
Public Const CKM_SSL3_MASTER_KEY_DERIVE = &H371
Public Const CKM_SSL3_KEY_AND_MAC_DERIVE = &H372
Public Const CKM_SSL3_MD5_MAC = &H380
Public Const CKM_SSL3_SHA1_MAC = &H381
Public Const CKM_MD5_KEY_DERIVATION = &H390
Public Const CKM_MD2_KEY_DERIVATION = &H391
Public Const CKM_SHA1_KEY_DERIVATION = &H392
Public Const CKM_PBE_MD2_DES_CBC = &H3A0
Public Const CKM_PBE_MD5_DES_CBC = &H3A1
Public Const CKM_PBE_MD5_CAST_CBC = &H3A2
Public Const CKM_PBE_MD5_CAST3_CBC = &H3A3
Public Const CKM_PBE_MD5_CAST5_CBC = &H3A4
Public Const CKM_PBE_MD5_CAST128_CBC = &H3A4
Public Const CKM_PBE_SHA1_CAST5_CBC = &H3A5
Public Const CKM_PBE_SHA1_CAST128_CBC = &H3A5
Public Const CKM_PBE_SHA1_RC4_128 = &H3A6
Public Const CKM_PBE_SHA1_RC4_40 = &H3A7
Public Const CKM_PBE_SHA1_DES3_EDE_CBC = &H3A8
Public Const CKM_PBE_SHA1_DES2_EDE_CBC = &H3A9
Public Const CKM_PBE_SHA1_RC2_128_CBC = &H3AA
Public Const CKM_PBE_SHA1_RC2_40_CBC = &H3AB

' CKM_PKCS5_PBKD2 is new for v2.10 '/
Public Const CKM_PKCS5_PBKD2 = &H3B0

Public Const CKM_PBA_SHA1_WITH_SHA1_HMAC = &H3C0
Public Const CKM_KEY_WRAP_LYNKS = &H400
Public Const CKM_KEY_WRAP_SET_OAEP = &H401

' Fortezza mechanisms '/
Public Const CKM_SKIPJACK_KEY_GEN = &H1000
Public Const CKM_SKIPJACK_ECB64 = &H1001
Public Const CKM_SKIPJACK_CBC64 = &H1002
Public Const CKM_SKIPJACK_OFB64 = &H1003
Public Const CKM_SKIPJACK_CFB64 = &H1004
Public Const CKM_SKIPJACK_CFB32 = &H1005
Public Const CKM_SKIPJACK_CFB16 = &H1006
Public Const CKM_SKIPJACK_CFB8 = &H1007
Public Const CKM_SKIPJACK_WRAP = &H1008
Public Const CKM_SKIPJACK_PRIVATE_WRAP = &H1009
Public Const CKM_SKIPJACK_RELAYX = &H100A
Public Const CKM_KEA_KEY_PAIR_GEN = &H1010
Public Const CKM_KEA_KEY_DERIVE = &H1011
Public Const CKM_FORTEZZA_TIMESTAMP = &H1020
Public Const CKM_BATON_KEY_GEN = &H1030
Public Const CKM_BATON_ECB128 = &H1031
Public Const CKM_BATON_ECB96 = &H1032
Public Const CKM_BATON_CBC128 = &H1033
Public Const CKM_BATON_COUNTER = &H1034
Public Const CKM_BATON_SHUFFLE = &H1035
Public Const CKM_BATON_WRAP = &H1036
Public Const CKM_ECDSA_KEY_PAIR_GEN = &H1040
Public Const CKM_ECDSA = &H1041
Public Const CKM_ECDSA_SHA1 = &H1042
Public Const CKM_JUNIPER_KEY_GEN = &H1060
Public Const CKM_JUNIPER_ECB128 = &H1061
Public Const CKM_JUNIPER_CBC128 = &H1062
Public Const CKM_JUNIPER_COUNTER = &H1063
Public Const CKM_JUNIPER_SHUFFLE = &H1064
Public Const CKM_JUNIPER_WRAP = &H1065
Public Const CKM_FASTHASH = &H1070

Public Const CKM_CMS_SIG = &H500
        Public Const CKM_VENDOR_DEFINED = &H80000000

